#include <string.h>
#include <zephyr.h>
#include <stdlib.h>
#include <stdio.h>
#include <net/socket.h>
#include <modem/bsdlib.h>
#include <net/tls_credentials.h>
#include <modem/lte_lc.h>
#include <modem/at_cmd.h>
#include <modem/at_notif.h>
#include <modem/modem_key_mgmt.h>
#include <drivers/spi.h>
#include <nrf_socket.h>
#include <device.h>


#define MAXLINE 4096
#define HTTPS_PORT 443
#define RECV_BUFF_SIZE 4096
#define SEND_BUFF_SIZE 4096
#define TLS_SEC_TAG 42

//e4828545-0c1b-429c-a932-f355de7a6307
#define SEND_DATA "{\"product_number\": \"200001-A\",\"serial_number\": \"10000001\",\"token\": \"5e9564ab-7ac4-4b26-8e5f-8222cdcdcf24\",\"firmware_token\": \"e4828545-0c1b-429c-a932-f355de7a6307\"}"

#define POST_TEMPLATE "POST %s? HTTP/1.1\r\n"                                       \
					  "Host: %s\r\n"                            \
					  "Connection: keep-alive\r\n"              \
					  "Content-Type: application/json\r\n"      \
					  "Content-length: %d\r\n\r\n"              \
					  "%s"

#define GET_TEMPLATE "GET %s HTTP/1.1\r\n"                                          \
					 "Host: %s\r\n"                             \
					 "Connection: keep-alive\r\n"               \
					 "Content-Type: application/json\r\n\r\n"


int at_comms_init();
int tls_setup(int fd);
char* parseRecv(const char *input);
void get_request(const char *path, const char *host);
void post_request(const char *path, const char *host, char *sendData);